SystemOrganization addCategory: #'Practica2-Ejercicio1'!
SystemOrganization addCategory: #'Practica2-Ejercicio2'!

Object subclass: #Empleado
	instanceVariableNames: 'nombre direccion estadoCivil fechaNacimiento sueldoBasico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!Empleado methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 00:31'!
calcularEdad
	"Mtodo que devuelve la edad de la persona en aos"

	| edad |
	edad := 0.
	edad := ((Date today - fechaNacimiento) days / 365.25) asInteger.
	^ edad! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:48'!
calcularSueldoBruto
	"comment stating purpose of message"

	| sueldoBruto |
	^sueldoBruto ! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:47'!
calcularSueldoNeto
	"comment stating purpose of message"
	| sueldoNeto|
	^sueldoNeto ! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:49'!
calcularTotalRetenciones
	"comment stating purpose of message"

	| totalRetenciones |
	^totalRetenciones! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:08'!
direccion
	^ direccion! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:54'!
direccion: aDireccion
	direccion := aDireccion! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:08'!
estadoCivil
	^ estadoCivil! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
estadoCivil: aEstadoCivil
	estadoCivil := aEstadoCivil! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:09'!
fechaNacimiento
	^ fechaNacimiento! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
fechaNacimiento: aFechaNacimiento
	fechaNacimiento := aFechaNacimiento! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:49'!
generarRecibo
	"comment stating purpose of message"

	| recibo |
	^recibo ! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:07'!
nombre
	^ nombre! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
nombre: aNombre
	nombre := aNombre! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:09'!
sueldoBasico
	^ sueldoBasico! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
sueldoBasico: aSueldoBasico
	sueldoBasico := aSueldoBasico! !

Empleado subclass: #EmpleadoPermanente
	instanceVariableNames: 'cantidadHijos antiguedad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:21'!
antiguedad
"Mtodo que retorna la antigedad del empleado de planta permanente en la empresa"
	^ antiguedad! !

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:21'!
antiguedad: anAntiguedad 
"Mtodo que asigna la cantidad en aos que representa la antigedad del empleado de planta permanente en la empresa"
	antiguedad := anAntiguedad ! !

!EmpleadoPermanente methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 23:56'!
calcularSueldoBruto
	"Mtodo para calcular el sueldo bruto de cada empleado de planta permanente"

	| sueldoBruto salarioFamiliar asignacionHijo asignacionConyuge asignacionAntiguedad |
	
	asignacionHijo := 150 * cantidadHijos.
	
	(estadoCivil ='Casado' | estadoCivil ='Casada')
	
	ifFalse:[asignacionConyuge := 0]	ifTrue:[asignacionConyuge := 100]. 

	asignacionAntiguedad := 50*antiguedad.
		
	salarioFamiliar :=  asignacionHijo + asignacionConyuge + asignacionAntiguedad.
	
	sueldoBruto := sueldoBasico + salarioFamiliar .
	
	
	^ sueldoBruto! !

!EmpleadoPermanente methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 22:43'!
calcularTotalRetenciones 
	"Este mtodo calcula el total de retenciones que tiene un empleado de planta permanente"

	| totalRetenciones obraSocial aportesjubilatorios  sueldoBruto|
	
	sueldoBruto := self calcularSueldoBruto.
	
	obraSocial := (0.1* sueldoBruto ) + (20*cantidadHijos).
	
	aportesjubilatorios := (0.15* sueldoBruto ).
	
	totalRetenciones := obraSocial + aportesjubilatorios.
	
	^totalRetenciones ! !

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:24'!
cantidadHijos
"Mtodo que retorna el nmero de hijos que tiene el empleado de planta permanente"
	^ cantidadHijos! !

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:25'!
cantidadHijos: aCantidadHijos 
"Mtodo que asigna el nmero de hijos que tiene el empleado de planta permanente"
	cantidadHijos := aCantidadHijos ! !

!EmpleadoPermanente methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:53'!
generarRecibo 
	"Mtodo que genera el recibo de haberes por cada empleado"

	| recibo renglon |
	
	recibo := ReciboHaberes new.
	
	recibo nombre: nombre.
	recibo direccion: direccion.
	recibo fechaEmision: Date today.
	recibo sueldoBruto: self calcularSueldoBruto.
	recibo sueldoNeto: super sueldoNeto.
	
	
		
	^recibo! !

Empleado subclass: #EmpleadoTemporario
	instanceVariableNames: 'cantidadHorasExtras finContrato'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!EmpleadoTemporario methodsFor: 'as yet unclassified' stamp: 'Olga LucÃ­a Sarmiento 6/13/2012 22:35'!
calcularSueldoBruto
	"Mtodo para calcular el sueldo bruto de cada empleado de planta temporario"
	|sueldoBruto|
	sueldoBruto := sueldoBasico + (cantidadHorasExtras * 40).
	^ sueldoBruto! !

!EmpleadoTemporario methodsFor: 'as yet unclassified' stamp: 'Olga LucÃ­a Sarmiento 6/13/2012 22:51'!
calcularTotalRetenciones 
	"Este mtodo calcula el total de retenciones que tiene un empleado de planta permanente"

	| totalRetenciones obraSocial aportesjubilatorios sueldoBruto edad|
	sueldoBruto :=	self calcularSueldoBruto.
	edad :=	super calcularEdad.
	obraSocial := (0.1* sueldoBruto).
	edad >50 ifTrue:  [obraSocial := obraSocial +25].
	aportesjubilatorios := (0.1* sueldoBruto) + (5 * cantidadHorasExtras).
	
	totalRetenciones := obraSocial + aportesjubilatorios.
	
	^totalRetenciones ! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'Olga LucÃ­a Sarmiento 6/13/2012 22:39'!
cantidadHorasExtra: aCantidadHorasExtra 
	cantidadHorasExtras := aCantidadHorasExtra ! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:44'!
cantidadHorasExtras
	^ cantidadHorasExtras! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:45'!
finContrato
	^ finContrato! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'Olga LucÃ­a Sarmiento 6/13/2012 22:39'!
finContrato: aFinContrato 
	finContrato := aFinContrato ! !

Object subclass: #Empresa
	instanceVariableNames: 'nombre CUIT empleados recibos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 00:38'!
CUIT
	^ CUIT! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:14'!
CUIT: aCUIT
	CUIT = aCUIT! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:15'!
addEmpleado: aEmpleado
	"Agrega un empleado al arreglo de empleados"
	! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/13/2012 01:01'!
calcularTotalRetenciones
	"Recorre la coleccin de empleados, obtiene la retencin de cada uno "

	| totalRetenciones|
	^totalRetenciones ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:55'!
calcularTotalSueldosBrutos
	"comment stating purpose of message"

	| totalSueldosBrutos |
	^totalSueldosBrutos ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:55'!
calcularTotalSueldosNetos
	"comment stating purpose of message"

	| totalSueldosNetos |
	^totalSueldosNetos ! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 00:39'!
empleados
	^ empleados! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/12/2012 23:52'!
nombre 
	^nombre! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:16'!
nombre: aNombre
	nombre = aNombre! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/12/2012 20:56'!
realizarLiquidacionSueldos
	"comment stating purpose of message"

	| temporary variable names |
	! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 00:39'!
recibos
	^ recibos! !

Object subclass: #ReciboHaberes
	instanceVariableNames: 'nombreEmpleado direccion fechaEmision sueldoBruto sueldoNeto renglones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:21'!
direccion 
	"Mtodo que retorna la direccin del empleado escrita en el recibo"

	^direccion ! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:20'!
direccion: direccionEmpleado
	"Mtodo que asigna la direccin del empleado al recibo"

	direccion := direccionEmpleado.! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:32'!
fechaEmision 
	"Mtodo que retorna la fecha de emisin del recibo"

	^fechaEmision ! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:29'!
fechaEmision: fechaRecibo
	"Mtodo que asigna la fecha de emisin del recibo"

	fechaEmision := fechaRecibo.! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:18'!
nombre
	"Mtodo que retorna el nombre del empleado"

	^nombreEmpleado! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:11'!
nombre: nombreEmp
	"Mtodo que asigna el nombre del empleado al recibo"
	
	nombreEmpleado := nombreEmp.
	! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 21:04'!
renglones
	
	| lineas|
	
	lineas := SortedCollection new.
	
	
	
	! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:37'!
sueldoBruto 
	"Mtodo que retorna el valor del sueldo bruto del empleado"

	^sueldoBruto ! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:34'!
sueldoBruto: salarioBruto
	"Mtodo que asigna el sueldo bruto del empleado al recibo"

	sueldoBruto := salarioBruto.
	! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:41'!
sueldoNeto 
	"Mtodo que retorna el sueldo neto del empleado"

	^sueldoNeto ! !

!ReciboHaberes methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 20:39'!
sueldoNeto: salarioNeto
	"Mtodo que asigna el sueldo neto del empleado al recibo"

	sueldoNeto := salarioNeto. ! !

Object subclass: #Renglon
	instanceVariableNames: 'concepto monto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!
